(*
 Procedures to modify an environment of defined expressions
 
 author: Christian Mueller
*)

local
    open AbstractSyntax Support
in

exception IdNotFound of info * string

type env

val create  : unit -> env    
val add     : env * string * Exp -> env
val delete  : env * string -> env
val get     : env * info * string -> Exp    
val find    : env * Exp -> string option
val getList : env -> (string*Exp) list

end
