(* -*-sml-*- *)

(* ----------------------------------------------------------------------
 * This file contains some test cases for the interpreter in "CC" mode. 
 * The other test files can also be used in CC mode.
 *
 * author: Christian Mueller
 * ---------------------------------------------------------------------*)     

switch tm cc

(* 
   1. first nice examples for dependent types: a function whose type
      of the second argument depends on the value of the first 
*)

rdef DType1 = \b:Bool. if b then Int else Bool

rdef f = \b:Bool.\x:DType1 b.x

rdef result_11 = 2 + f true 3
rdef result_12 = not (f false true)


(* 
  2. the use of Fixpoint operators on type level illustrates that type-checking
     in CC with recursive types is in principle undecidable 
*)

rdef omega = \f:(Int->* )->(Int->* ).
               (\x:mu X.X->(Int->* ).\y:Int. 
                      f ((unfold (mu X.X->(Int->* )) x) x) y)

rdef Fix = \f:(Int->* )->(Int->* ).
               (omega f) (fold (mu X.X->(Int->* )) (omega f))

rdef DType2 = Fix (\f:Int->*.\n:Int. if n=0 then Unit else Unit -> f(n-1) ) 

rdef f = \n:Int. \f:DType2 n. unit

rdef result_21 = (f 0) unit
rdef result_22 = (f 1) (\x:Unit.x)
rdef result_23 = (f 3) (\x:Unit.\y:Unit.\z:Unit.z)

(* 
   3. divergent types:
      - using "equiv result_31, result_31" does terminate due to the 
	      construction of equiv 
      - comparing result_31 and result_32 diverges 
*)

(* change the setting of PP, so that there is no sync with the Environment,
   as "equiv result_31, result_32 diverges *)

switch pm o

def R = mu X.X->*

def result_31 = \Z.(\x:R.(unfold R x) x) (fold R (\x:R.(unfold R x) x))
def result_32 = \Z. result_31 Z

(* further test cases which show more dependent types *)

def F = \f:(Int->* )->Int->*.\x:fix f 2 .1

def i = if true then F else F
